<?php
$start = microtime();

require_once 'ipap-config.php';
require_once $path_lib.'functions.php';
require_once $path_lib.'template.php';
require_once $path_lib.'ez_sql.php';



/* =========================================================================
    //! display a folder/album
========================================================================= */
if (  isset($_GET['a'])  ) {



    $a = $_GET['a']; // error checking for $a should be here
    $a = strip_tags($a);

    if (isset($_GET['i'])) {
        $i = intval($_GET['i']);
    } else {
        $i = '';
    } // check if $i is really part of the album 2005-05-19 (Thursday)



    $visible = $db->get_var("SELECT visible FROM $table_albums WHERE slug='$a'");

    if (!$visible) { // no such album
        header('Location:'.$gallery_url);
        exit;
    } elseif ($visible != 'Y' && !$allow_view_hidden) { // hidden gallery & allow_view_hidden not allowed!
        header('Location:'.$gallery_url);
        exit;
    }




    $tpl = & new sqlCache($table_cache, 'album'.$a.$i, $cache_life);


    if ( !$tpl->is_cached() ) {


        $tpl->set('timestamp', date('r'));
        $tpl->set('ipap_version', $ipap_version);

        $tpl->set('site_name', $site_name);
        $tpl->set('site_url', $site_url);
        $tpl->set('gallery_name', $gallery_name);
        $tpl->set('gallery_url', $gallery_url);
        $tpl->set('thumbnail_size', $thumbnail_size);

        // album listing
        $album_list = @get_albums_for_frontpage();
        $tpl->set('albums', $album_list);


        $label_list = @get_label_list();
        $tpl->set('labels', $label_list);
        $label_csv = @get_label_list_csv();
        $tpl->set('labels_csv', $label_csv);


        // thumbnails for this album
        $thumbnail_list = @get_thumbnails_for_album();
        $tpl->set('thumbnails', $thumbnail_list);

        // info for this album
        $album_info = @get_album_info();
        $tpl->set('current_album', $album_info);

        // current photo
        $current_photo = @get_current_photo();
        $tpl->set('current_photo', $current_photo);

        // labels for this album
        $album_labels_csv = @get_labels_for_album_csv();
        $tpl->set('album_labels_csv', $album_labels_csv);


/* begin 0.9 tags */
            $settings = @get_settings();
        $tpl->set('settings', $settings);
/* end 0.9 tags */



    }


    $tpl->display_cache($path_templates.$template_path.'/'.$album_tpl);




/*
proposal for single photo mode
    if ($i > 0 && file_exists($path_templates.$template_path.'/'.$photo_tpl)) {
        echo $tpl->fetch_cache($path_templates.$template_path.'/'.$photo_tpl);
    } else {
        echo $tpl->fetch_cache($path_templates.$template_path.'/'.$album_tpl);
    }
 */









/* =========================================================================
    //! label display
            label display is in many ways the same as frontpage display.
========================================================================= */
} elseif (  isset($_GET['l'])  ) {

    $l = $_REQUEST['l'];
    $l = strip_tags($l);


    // move checking before caching! 2005-05-19 (Thursday)
    $visible = $db->get_var("SELECT visible FROM $table_labels WHERE slug='$l'");
    if (!$visible) { // no such label
        header('Location:'.$gallery_url);
        exit;
    } elseif ($visible != 'Y' && !$allow_view_hidden) { // hidden gallery & allow_view_hidden not allowed!
        header('Location:'.$gallery_url);
        exit;
    }


    $tpl = & new sqlCache($table_cache, 'label'.$l, $cache_life);

    if ( !$tpl->is_cached() ) {


        $tpl->set('timestamp', date('r'));
        $tpl->set('ipap_version', $ipap_version);

        $tpl->set('site_name', $site_name);
        $tpl->set('site_url', $site_url);
        $tpl->set('gallery_name', $gallery_name);
        $tpl->set('gallery_url', $gallery_url);
        $tpl->set('thumbnail_size', $thumbnail_size);

        $album_list = @get_albums_for_label($l);
        $tpl->set('albums', $album_list);

        $label_list = @get_label_list();
        $tpl->set('labels', $label_list);
        $label_csv = @get_label_list_csv();
        $tpl->set('labels_csv', $label_csv);

        $curr_label = @get_current_label($l);
        $tpl->set('current_label', $curr_label);

/* begin 0.9 tags */
            $settings = @get_settings();
        $tpl->set('settings', $settings);
/* end 0.9 tags */



    }

    $tpl->display_cache($path_templates.$template_path.'/'.$gallery_tpl);



/*
proposal for single photo mode
    if (file_exists($path_templates.$template_path.'/'.$label_tpl)) {
        echo $tpl->fetch_cache($path_templates.$template_path.'/'.$label_tpl);
    } else {
        echo $tpl->fetch_cache($path_templates.$template_path.'/'.$gallery_tpl);
    }
 */













/* =========================================================================
    //! gallery front page display
========================================================================= */
} elseif (   !isset($_GET['a'])  &&  !isset($_GET['l'])   ) {
    // index display




    $tpl = & new sqlCache($table_cache, 'gallery', $cache_life);

    if ( !$tpl->is_cached() ) {

        $tpl->set('timestamp', date('r'));
        $tpl->set('ipap_version', $ipap_version);

        $tpl->set('site_name', $site_name);
        $tpl->set('site_url', $site_url);
        $tpl->set('gallery_name', $gallery_name);
        $tpl->set('gallery_url', $gallery_url);
        $tpl->set('thumbnail_size', $thumbnail_size);

        $album_list = @get_albums_for_frontpage();
        $tpl->set('albums', $album_list);

        $label_list = @get_label_list();
        $tpl->set('labels', $label_list);
        $label_csv = @get_label_list_csv();
        $tpl->set('labels_csv', $label_csv);


/* begin 0.9 tags */
            $settings = @get_settings();
        $tpl->set('settings', $settings);
/* end 0.9 tags */



    }

    $tpl->display_cache($path_templates.$template_path.'/'.$gallery_tpl);


}


$end = microtime();
if ($ipap_show_timer) {
    echo "\nDebug info: output in ".microtime_diff($end,$start).' seconds, '.$db->num_queries." queries.\n";
} else {
    echo "\n<!-- Debug info: output in ".microtime_diff($end,$start).' seconds, '.$db->num_queries." queries. -->\n";
}
?>